#include<bits/stdc++.h>
using std::cin;
using std::cout;
using ll=long long;
const int LogN=20,N=5e5+10;

int n,q,cnt;
int hd[N],to[N<<1],nt[N<<1];
int dep[N],dfn[N],fa[N];
int lg[N]={-1},f[LogN][N],st[LogN][N];
void add(int u,int v){
	to[++cnt]=v,nt[cnt]=hd[u],hd[u]=cnt;
	to[++cnt]=u,nt[cnt]=hd[v],hd[v]=cnt;
}
void dfs(int u){
	f[0][dfn[u]=++cnt]=fa[u];
	for(int e=hd[u];e;e=nt[e]){
		int v=to[e];
		if(v==fa[u])continue;
		dep[v]=dep[u]+1,fa[v]=u;
		dfs(v);
	}
}
int getmin(int u,int v){
	return dfn[u]<dfn[v]?u:v;
}
void init_LCA(){
	cnt=0,dep[1]=1,dfs(1);
	for(int i=1;i<=n;++i)lg[i]=lg[i>>1]+1;
	for(int i=1;i<=lg[n];++i)
		for(int j=1;j<=n-(1<<i)+1;++j)
			f[i][j]=getmin(f[i-1][j],f[i-1][j+(1<<i-1)]);
}
int lca(int u,int v){
	if(u==v)return u;
	int l=dfn[u],r=dfn[v];
	if(l>r)std::swap(l,r);++l;
	int x=lg[r-l+1];
	return getmin(f[x][l],f[x][r-(1<<x)+1]);
}
void init_ST(){
	for(int i=1;i<=n;++i)st[0][i]=i;
	for(int i=1;i<=lg[n];++i)
		for(int j=1;j<=n-(1<<i)+1;++j)
			st[i][j]=lca(st[i-1][j],st[i-1][j+(1<<i-1)]);
}
int query(int l,int r){
	int x=lg[r-l+1];
	return dep[lca(st[x][l],st[x][r-(1<<x)+1])];
}
int main(){
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	cin.tie(0)->sync_with_stdio(0);
	cin>>n;
	for(int i=1,u,v;i<n;++i)
		cin>>u>>v,add(u,v);
	init_LCA(),init_ST();
	cin>>q;
	while(q--){
		int l,r,k,ans=0;
		cin>>l>>r>>k;
		for(int i=l;i<=r-k+1;++i)
			ans=std::max(ans,query(i,i+k-1));
		cout<<ans<<'\n';
	}
	return 0;
}
